Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material	(revision 1862)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material	(revision 1863)
@@ -196,5 +196,5 @@
 			param_named F0 float3 0.95 0.95 0.95
 			param_named SingleBounce float 0.0
-			param_named refIndex float 200			
+			param_named refIndex float 0.909			
 		} 
 		
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapotNew.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapotNew.hlsl	(revision 1862)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapotNew.hlsl	(revision 1863)
@@ -13,9 +13,10 @@
 }
 
-#define MAX_LIN_ITERATIONCOUNT 80
-#define MIN_LIN_ITERATIONCOUNT 30
+#define MAX_LIN_ITERATIONCOUNT 40  //80
+#define MIN_LIN_ITERATIONCOUNT 20  //60
 #define SECANT_ITERATIONCOUNT 2
-#define MAX_RAY_DEPTH 4
-
+#define MAX_RAY_DEPTH 5
+
+/*
 void linearSearch(  float3 x, float3 R, float3 N, samplerCUBE mp,
                     out float3 p,
@@ -61,14 +62,66 @@
    t += dt;  
  }
- 
+
  if(!overshoot)
   p = float3(0,0,0);
-/* else if(t == 2 * dt)
+}
+*/
+
+
+void linearSearch(  float3 x, float3 R, float3 N, samplerCUBE mp,
+                    out float3 p,
+                    out float dl,
+                    out float dp,
+                    out float llp,
+                    out float ppp)
+{
+ float3 Ra = abs(R), xa = abs(x);
+ float xm =  max(max(xa.x,xa.y),xa.z);
+ float Rm = max(max(Ra.x,Ra.y),Ra.z);
+ float a = xm / Rm;
+ 
+ int shootL = 0, shootP = 0;          
+ bool found = false; 
+ 
+ float dt =  length(x / xm - R / Rm) * MAX_LIN_ITERATIONCOUNT;
+ dt = max(dt, MIN_LIN_ITERATIONCOUNT);
+ dt = 1.0 / dt;
+    
+ float t = 0.01;//dt;
+ float pa;
+ 
+ //Linear iteration
+ while(t <= 1.0 && !found)
  {
-	 float3 hitp = pa * normalize(p);
-    if(dot(normalize(hitp - x), N) < 0.1f)
-	   p = float3(0,0,0);
- }*/
-}
+   dp = a * t / (1 - t);
+   p = x + R * dp;
+   pa = readDistanceCubeMap(mp, p);
+      
+   if(pa > 0)
+   {
+    ppp = length(p) / pa;
+    if(ppp < 1)
+      shootP = -1;
+    else 
+      shootP = 1;      
+    if(shootL * shootP == -1)
+      found = true;
+    else
+    {
+      shootL = shootP;
+      dl = dp;
+      llp = ppp;
+    }
+   }
+   else
+     shootL = 0;
+      
+   t += dt;  
+ }
+
+ if(!found)
+  p = float3(0,0,0);
+}
+
 
 void secantSearch(float3 x, float3 R, samplerCUBE mp, 
@@ -220,6 +273,5 @@
 	 float4 I = float4(0,0,0,0);
 			
-	 float3 N = normalize(IN.mNormal);// * refIndex;
-	 float3 newTexCoord;	
+	 float3 N = normalize(IN.mNormal);
 	 float3 x = IN.wPos - lastCenter;
 	 float3 V  = (IN.wPos - cameraPos);
@@ -231,13 +283,16 @@
 	 while(depth < MAX_RAY_DEPTH)
 	 {
-	   float3 R;
-	  // float refIndex = length(N);
-	  // refIndex = 1.0 / refIndex;
-	  // N = normalize(N);
-	   
-	   //if(refIndex > 100.0)
-	    R = normalize(reflect( V, N));
-	  // else
-	  //  R = normalize(refract( V, N, refIndex));
+	   float3 R;  
+	   //  R = normalize(reflect( V, N));	  
+	  
+	  float ri = refIndex;
+	  
+	  if(dot(V,N) > 0)
+	  {
+	    ri = 1.0 / ri;
+	    N = -N;	    
+	  }
+	  R = refract( V, N, ri);
+	  if(dot(R,R) == 0) R = reflect( V, -N); 
 				
 	   float3 Nl;
@@ -246,6 +301,5 @@
 	   if(Il.a == 0)
 	   {
-		   depth += 1;
-		  // I = float4(0.2,0.2,0.2,1.0);
+		   depth += 1;		 
 	   }
 	   else
@@ -256,9 +310,32 @@
 	   x = l;	   
 	   N = normalize(Nl);
-	   V = R;
-	   
-	  //if(refIndex <= 100.0)
-	    if(dot(N, V) > 0) N = -N;
+	   V = R;	   	   
 	}
+	/*
+	N = normalize(IN.mNormal);
+	x = IN.wPos - lastCenter;
+	V  = (IN.wPos - cameraPos);
+	depth = 0;
+	while(depth < MAX_RAY_DEPTH)
+	 {
+	   float3 R;  
+	   R = normalize(reflect( V, N));	  
+	  	
+	   float3 Nl;
+	   float4 Il;
+	   l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, Il, Nl);
+	   if(Il.a == 0)
+	   {
+		   depth += 1;		 
+	   }
+	   else
+	   {
+		   I = Il * 0.2 + I * 0.8;
+		   depth = MAX_RAY_DEPTH;
+	   }
+	   x = l;	   
+	   N = Nl;
+	   V = R;   
+	}*/
 	
 	//if(I.a == 0)
@@ -282,5 +359,5 @@
 	 Color = SingleReflectionPS(IN,cameraPos, CubeMap, DistanceMap, NormDistMap1,NormDistMap2,lastCenter,refIndex);
 	else
-	 Color = MultipleReflectionPS(IN,cameraPos, CubeMap, DistanceMap, NormDistMap2,NormDistMap2,lastCenter,refIndex);
+	 Color = MultipleReflectionPS(IN,cameraPos, CubeMap, DistanceMap, NormDistMap1,NormDistMap2,lastCenter,refIndex);
 	 
 	return Color;
Index: GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1862)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1863)
@@ -404,14 +404,30 @@
      	SceneNode* rootNode = mSceneMgr->getRootSceneNode();
 		
-		mCamera->setPosition(6.564,4.328,0.059);
-		mCamera->lookAt(Vector3(0.4,0.16,0.25));
-		
-		Entity* object = mSceneMgr->createEntity("object", "teapot.mesh");
+		bool teapot = true;
+		//mCamera->getParentSceneNode()->translate(Vector3(6.564,4.328,0.059));
+		//mCamera->setPosition(4.0,4.2,-3.5);
+		mCamera->setPosition(7.0,2.6,-0.5);
+		mCamera->lookAt(Vector3(1.0, 0.0,0.6));
+		Entity* object;
+
+		if(teapot)
+		 object = mSceneMgr->createEntity("object", "teapot.mesh");
+		else
+		 object = mSceneMgr->createEntity("object", "sphere.mesh");
 		object->setMaterialName("MetalTeapotMultipleBounce");
 		objectNode = rootNode->createChildSceneNode();
 		objectNode->attachObject(object);
-		//objectNode->scale(0.5,0.5,0.5);
-		objectNode->scale(2.7,2.7,2.7);
-		objectNode->setPosition(0,0.7,0.0);
+
+		if(teapot)
+		{
+		  objectNode->scale(2.7,2.7,2.7);
+		  objectNode->setPosition(0,0.7,0.0);
+		}
+		else
+		{
+		  objectNode->scale(0.027,0.027,0.027);		
+		  objectNode->setPosition(1,0.0,1.0);
+		}
+
 		objectNode->_updateBounds();
 
Index: GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 1862)
+++ GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 1863)
@@ -5,6 +5,6 @@
 Anti aliasing=Level 4
 Floating-point mode=Fastest
-Full Screen=Yes
-Rendering Device=NVIDIA GeForce 6800 GT
+Full Screen=No
+Rendering Device=NVIDIA GeForce 7950 GX2
 VSync=No
 Video Mode=800 x 600 @ 32-bit colour
